import { Vector } from "@bearmetal/doodler";
import { TrackSegment } from "./track/system.ts";

declare global {
  type End = {
    pos: Vector;
    segment: TrackSegment;
    tangent: Vector;
    frontOrBack: "front" | "back";
  };

  type SerializedTrackSegment = {
    p: [number, number, number][];
    id: string;
    bNeighbors: string[];
    fNeighbors: string[];
  };

  type Debug = {
    track: boolean;
    segment: boolean;
    train: boolean;
    car: boolean;
    path: boolean;
    bogies: boolean;
    angles: boolean;
    aabb: boolean;
  };

  type AABB = {
    pos: Vector;
    x: number;
    y: number;
    width: number;
    height: number;
    center: Vector;
  };

  type tag = string | number;
}

export function applyMixins(derivedCtor: any, baseCtors: any[]) {
  baseCtors.forEach((baseCtor) => {
    Object.getOwnPropertyNames(baseCtor.prototype).forEach((name) => {
      Object.defineProperty(
        derivedCtor.prototype,
        name,
        Object.getOwnPropertyDescriptor(baseCtor.prototype, name) ?? {},
      );
    });
  });
}
